Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34921)
@@ -3118,67 +3966,114 @@
             if ($buff =~ /^\0\0/) {
                 $fmt = 'N';     # UTF-32 MM with or without BOM
-            } elsif ($buff =~ /^..\0\0/) {
+            } elsif ($buff =~ /^..\0\0/s) {
                 $fmt = 'V';     # UTF-32 II with or without BOM
             } elsif (not $fmt) {
                 if ($buff =~ /^\0/) {
                     $fmt = 'n'; # UTF-16 MM without BOM
-                } elsif ($buff =~ /^.\0/) {
+                } elsif ($buff =~ /^.\0/s) {
                     $fmt = 'v'; # UTF-16 II without BOM
                 }
             }
         }
-        $raf->Seek(0, 2) or return 0;
-        my $size = $raf->Tell() or return 0;
-        $raf->Seek(0, 0) or return 0;
-        $raf->Read($buff, $size) == $size or return 0;
-        # decode the first layer of double-encoded UTF text
-        if ($double) {
-            $buff = substr($buff, length $double);  # remove leading BOM
-            Image::ExifTool::SetWarning(undef);     # clear old warning
-            local $SIG{'__WARN__'} = \&Image::ExifTool::SetWarning;
-            my $tmp;
-            # assume that character data has been re-encoded in UTF, so re-pack
-            # as characters and look for warnings indicating a false assumption
-            if ($double eq "\xef\xbb\xbf") {
-                require Image::ExifTool::Charset;
-                my $uni = Image::ExifTool::Charset::Decompose(undef,$buff,'UTF8');
-                $tmp = pack('C*', @$uni);
-            } else {
-                my $fmt = ($double eq "\xfe\xff") ? 'n' : 'v';
-                $tmp = pack('C*', unpack("$fmt*",$buff));
-            }
-            if (Image::ExifTool::GetWarning()) {
-                $exifTool->Warn('Superfluous BOM at start of XMP');
-            } else {
-                $exifTool->Warn('XMP is double UTF-encoded');
-                $buff = $tmp;   # use the decoded XMP
-            }
-            $size = length $buff;
-        }
-        $dataPt = \$buff;
-        $dirStart = 0;
-        $dirLen = $dataLen = $size;
-        unless ($type) {
+        my $size;
+        if ($type) {
+            if ($type eq 'PLIST') {
+                my $ext = $$et{FILE_EXT};
+                $type = $ext if $ext and $ext eq 'MODD';
+                $tagTablePtr = GetTagTable('Image::ExifTool::PLIST::Main');
+                $$dirInfo{XMPParseOpts}{FoundProc} = \&Image::ExifTool::PLIST::FoundTag;
+            }
+        } else {
             if ($isSVG) {
                 $type = 'SVG';
             } elsif ($isXML and not $hasXMP and not $isRDF) {
                 $type = 'XML';
-            }
-        }
-        $exifTool->SetFileType($type);
-    }
-
-    # take substring if necessary
-    if ($dataLen != $dirStart + $dirLen) {
-        $buff = substr($$dataPt, $dirStart, $dirLen);
+                my $ext = $$et{FILE_EXT};
+                $type = $ext if $ext and $ext eq 'COS'; # recognize COS by extension
+            }
+        }
+        $et->SetFileType($type, $mime);
+
+        my $fast = $et->Options('FastScan');
+        return 1 if $fast and $fast == 3;
+
+        if ($type and $type eq 'INX') {
+            # brute force search for first XMP packet in INX file
+            # start: '<![CDATA[<?xpacket begin' (24 bytes)
+            # end:   '<?xpacket end="r"?>]]>'   (22 bytes)
+            $raf->Seek(0, 0) or return 0;
+            $raf->Read($buff, 65536) or return 1;
+            for (;;) {
+                last if $buff =~ /<!\[CDATA\[<\?xpacket begin/g;
+                $raf->Read($buf2, 65536) or return 1;
+                $buff = substr($buff, -24) . $buf2;
+            }
+            $buff = substr($buff, pos($buff) - 15); # (discard '<![CDATA[' and before)
+            for (;;) {
+                last if $buff =~ /<\?xpacket end="[rw]"\?>\]\]>/g;
+                my $n = length $buff;
+                $raf->Read($buf2, 65536) or $et->Warn('Missing xpacket end'), return 1;
+                $buff .= $buf2;
+                pos($buff) = $n - 22;   # don't miss end pattern if it was split
+            }
+            $size = pos($buff) - 3;     # (discard ']]>' and after)
+            $buff = substr($buff, 0, $size);
+        } else {
+            # read the entire file
+            $raf->Seek(0, 2) or return 0;
+            $size = $raf->Tell() or return 0;
+            $raf->Seek(0, 0) or return 0;
+            $raf->Read($buff, $size) == $size or return 0;
+        }
         $dataPt = \$buff;
         $dirStart = 0;
+        $dirLen = $dataLen = $size;
     }
-    # extract XMP as a block if specified
-    if (($exifTool->{REQ_TAG_LOOKUP}{xmp} or $exifTool->{OPTIONS}{Binary}) and not $isSVG) {
-        $exifTool->FoundTag('XMP', substr($$dataPt, $dirStart, $dirLen));
+
+    # decode the first layer of double-encoded UTF text (if necessary)
+    if ($double) {
+        my ($buf2, $fmt);
+        $buff = substr($$dataPt, $dirStart + length $double); # remove leading BOM
+        Image::ExifTool::SetWarning(undef); # clear old warning
+        local $SIG{'__WARN__'} = \&Image::ExifTool::SetWarning;
+        # assume that character data has been re-encoded in UTF, so re-pack
+        # as characters and look for warnings indicating a false assumption
+        if ($double eq "\xef\xbb\xbf") {
+            require Image::ExifTool::Charset;
+            my $uni = Image::ExifTool::Charset::Decompose(undef,$buff,'UTF8');
+            $buf2 = pack('C*', @$uni);
+        } else {
+            if (length($double) == 2) {
+                $fmt = ($double eq "\xfe\xff") ? 'n' : 'v';
+            } else {
+                $fmt = ($double eq "\0\0\xfe\xff") ? 'N' : 'V';
+            }
+            $buf2 = pack('C*', unpack("$fmt*",$buff));
+        }
+        if (Image::ExifTool::GetWarning()) {
+            $et->Warn('Superfluous BOM at start of XMP');
+            $dataPt = \$buff;   # use XMP with the BOM removed
+        } else {
+            $et->Warn('XMP is double UTF-encoded');
+            $dataPt = \$buf2;   # use the decoded XMP
+        }
+        $dirStart = 0;
+        $dirLen = $dataLen = length $$dataPt;
     }
-    if ($exifTool->Options('Verbose') and not $exifTool->{XMP_CAPTURE}) {
-        $exifTool->VerboseDir($isSVG ? 'SVG' : 'XMP', 0, $dirLen);
+
+    # extract XMP/XML as a block if specified
+    my $blockName = $$dirInfo{BlockInfo} ? $$dirInfo{BlockInfo}{Name} : 'XMP';
+    if (($$et{REQ_TAG_LOOKUP}{lc $blockName} or ($$et{TAGS_FROM_FILE} and
+        not $$et{EXCL_TAG_LOOKUP}{lc $blockName})) and
+        (($$et{FileType} eq 'XMP' and $blockName eq 'XMP') or
+        ($$dirInfo{DirName} and $$dirInfo{DirName} eq $blockName)))
+    {
+        $et->FoundTag($$dirInfo{BlockInfo} || 'XMP', substr($$dataPt, $dirStart, $dirLen));
+    }
+
+    $tagTablePtr or $tagTablePtr = GetTagTable('Image::ExifTool::XMP::Main');
+    if ($et->Options('Verbose') and not $$et{XMP_CAPTURE}) {
+        my $dirType = $isSVG ? 'SVG' : $$tagTablePtr{GROUPS}{1};
+        $et->VerboseDir($dirType, 0, $dirLen);
     }
 #
@@ -3186,22 +4081,25 @@
 #
     my $begin = '<?xpacket begin=';
+    my $dirEnd = $dirStart + $dirLen;
     pos($$dataPt) = $dirStart;
-    delete $$exifTool{XMP_IS_XML};
-    delete $$exifTool{XMP_IS_SVG};
+    delete $$et{XMP_IS_XML};
+    delete $$et{XMP_IS_SVG};
     if ($isXML or $isRDF) {
-        $$exifTool{XMP_IS_XML} = $isXML;
-        $$exifTool{XMP_IS_SVG} = $isSVG;
-        $$exifTool{XMP_NO_XPACKET} = 1 + $bom;
+        $$et{XMP_IS_XML} = $isXML;
+        $$et{XMP_IS_SVG} = $isSVG;
+        $$et{XMP_NO_XPACKET} = 1 + $bom;
     } elsif ($$dataPt =~ /\G\Q$begin\E/gc) {
-        delete $$exifTool{XMP_NO_XPACKET};
-    } elsif ($$dataPt =~ /<x(mp)?:x[ma]pmeta/gc) {
-        $$exifTool{XMP_NO_XPACKET} = 1 + $bom;
+        delete $$et{XMP_NO_XPACKET};
+    } elsif ($$dataPt =~ /<x(mp)?:x[ma]pmeta/gc and
+             pos($$dataPt) > $dirStart and pos($$dataPt) < $dirEnd)
+    {
+        $$et{XMP_NO_XPACKET} = 1 + $bom;
     } else {
-        delete $$exifTool{XMP_NO_XPACKET};
+        delete $$et{XMP_NO_XPACKET};
         # check for UTF-16 encoding (insert one \0 between characters)
         $begin = join "\0", split //, $begin;
         # must reset pos because it was killed by previous unsuccessful //g match
         pos($$dataPt) = $dirStart;
-        if ($$dataPt =~ /\G(\0)?\Q$begin\E\0./g) {
+        if ($$dataPt =~ /\G(\0)?\Q$begin\E\0./sg) {
             # validate byte ordering by checking for U+FEFF character
             if ($1) {
@@ -3215,5 +4113,5 @@
             $begin =~ s/\0/\0\0\0/g;
             pos($$dataPt) = $dirStart;
-            if ($$dataPt !~ /\G(\0\0\0)?\Q$begin\E\0\0\0./g) {
+            if ($$dataPt !~ /\G(\0\0\0)?\Q$begin\E\0\0\0./sg) {
                 $fmt = 0;   # set format to zero as indication we didn't find encoded XMP
             } elsif ($1) {
@@ -3224,9 +4122,9 @@
             }
         }
-        defined $fmt or $exifTool->Warn('XMP character encoding error');
+        defined $fmt or $et->Warn('XMP character encoding error');
     }
     if ($fmt) {
         # trim if necessary to avoid converting non-UTF data
-        if ($dirStart or $dirLen != length($$dataPt) - $dirStart) {
+        if ($dirStart or $dirEnd != length($$dataPt)) {
             $buff = substr($$dataPt, $dirStart, $dirLen);
             $dataPt = \$buff;
@@ -3241,20 +4139,51 @@
         $dirStart = 0;
         $dirLen = length $$dataPt;
+        $dirEnd = $dirStart + $dirLen;
     }
-    # initialize namespace translation
-    $xlatNamespace = \%stdXlatNS;
-
     # avoid scanning for XMP later in case ScanForXMP is set
-    $$exifTool{FoundXMP} = 1;
+    $$et{FoundXMP} = 1 if $tagTablePtr eq \%Image::ExifTool::XMP::Main;
 
     # set XMP parsing options
-    $$exifTool{XMPParseOpts} = $$dirInfo{XMPParseOpts};
+    $$et{XMPParseOpts} = $$dirInfo{XMPParseOpts};
+
+    # ignore any specified properties (XML hack)
+    if ($$dirInfo{IgnoreProp}) {
+        %ignoreProp = %{$$dirInfo{IgnoreProp}};
+    } else {
+        undef %ignoreProp;
+    }
 
     # need to preserve list indices to be able to handle multi-dimensional lists
-    $$exifTool{NO_LIST} = 1 if $exifTool->Options('Struct');
+    my $keepFlat;
+    if ($$et{OPTIONS}{Struct}) {
+        if ($$et{OPTIONS}{Struct} eq '2') {
+            $keepFlat = 1;      # preserve flattened tags
+            # setting NO_LIST to 0 combines list items in a TAG_EXTRA "NoList" element
+            # to allow them to be re-listed later if necessary.  A "NoListDel" element
+            # is also created for tags that wouldn't have existed.
+            $$et{NO_LIST} = 0;
+        } else {
+            $$et{NO_LIST} = 1;
+        }
+    }
+
+    # don't generate structures if this isn't real XMP
+    $$et{NO_STRUCT} = 1 if $$dirInfo{BlockInfo} or $$dirInfo{NoStruct};
 
     # parse the XMP
-    $tagTablePtr or $tagTablePtr = GetTagTable('Image::ExifTool::XMP::Main');
-    $rtnVal = 1 if ParseXMPElement($exifTool, $tagTablePtr, $dataPt, $dirStart);
+    if (ParseXMPElement($et, $tagTablePtr, $dataPt, $dirStart, $dirEnd)) {
+        $rtnVal = 1;
+    } elsif ($$dirInfo{DirName} and $$dirInfo{DirName} eq 'XMP') {
+        # if DirName was 'XMP' we expect well-formed XMP, so set Warning since it wasn't
+        # (but allow empty XMP as written by some PhaseOne cameras)
+        my $xmp = substr($$dataPt, $dirStart, $dirLen);
+        if ($xmp =~ /^ *\0*$/) {
+            $et->Warn('Invalid XMP');
+        } else {
+            $et->Warn('Empty XMP',1);
+            $rtnVal = 1;
+        }
+    }
+    delete $$et{NO_STRUCT};
 
     # return DataPt if successful in case we want it for writing
@@ -3262,13 +4191,17 @@
 
     # restore structures if necessary
-    if ($$exifTool{IsStruct}) {
+    if ($$et{IsStruct}) {
         require 'Image/ExifTool/XMPStruct.pl';
-        RestoreStruct($exifTool);
-        delete $$exifTool{IsStruct};
+        RestoreStruct($et, $keepFlat);
+        delete $$et{IsStruct};
     }
     # reset NO_LIST flag (must do this _after_ RestoreStruct() above)
-    delete $$exifTool{NO_LIST};
-
-    undef %curNS;
+    delete $$et{NO_LIST};
+    delete $$et{XMPParseOpts};
+    delete $$et{curURI};
+    delete $$et{curNS};
+    delete $$et{xlatNS};
+    delete $$et{definedNS};
+
     return $rtnVal;
 }
@@ -3296,5 +4229,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP2.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP2.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP2.pl	(revision 34921)
@@ -2,5 +2,5 @@
 # File:         XMP2.pl
 #
-# Description:  Additional XMP schema definitions
+# Description:  Additional XMP namespace definitions
 #
 # Revisions:    10/12/2008 - P. Harvey Created
@@ -9,8 +9,12 @@
 #               2) PRISM - http://www.prismstandard.org/
 #               3) http://www.portfoliofaq.com/pfaq/v7mappings.htm
+#               4) http://www.iptc.org/IPTC4XMP/
 #               5) http://creativecommons.org/technology/xmp
 #                  --> changed to http://wiki.creativecommons.org/Companion_File_metadata_specification (2007/12/21)
 #               6) http://www.optimasc.com/products/fileid/xmp-extensions.pdf
 #               9) http://www.w3.org/TR/SVG11/
+#               11) http://www.extensis.com/en/support/kb_article.jsp?articleNumber=6102211
+#               12) XMPSpecificationPart3_May2013, page 58
+#               13) https://developer.android.com/training/camera2/Dynamic-depth-v1.0.pdf
 #------------------------------------------------------------------------------
 
@@ -21,5 +25,9 @@
 use Image::ExifTool::XMP;
 
-# structure definitions
+sub Init_crd($);
+
+#------------------------------------------------------------------------------
+
+# xmpDM structure definitions
 my %sCuePointParam = (
     STRUCT_NAME => 'CuePointParam',
@@ -68,13 +76,84 @@
     },
     timeValue   => { },
-    value       => { Writable => 'integer' },
-);
-
-# XMP Dynamic Media schema properties (xmpDM)
+    value       => { Writable => 'integer', Notes => 'only in XMP 2008 spec; an error?' },
+);
+my %sPose = (
+    STRUCT_NAME => 'Pose',
+    NAMESPACE => { Pose => 'http://ns.google.com/photos/dd/1.0/pose/' },
+    PositionX => { Writable => 'real', Groups => { 2 => 'Location' } },
+    PositionY => { Writable => 'real', Groups => { 2 => 'Location' } },
+    PositionZ => { Writable => 'real', Groups => { 2 => 'Location' } },
+    RotationX => { Writable => 'real', Groups => { 2 => 'Location' } },
+    RotationY => { Writable => 'real', Groups => { 2 => 'Location' } },
+    RotationZ => { Writable => 'real', Groups => { 2 => 'Location' } },
+    RotationW => { Writable => 'real', Groups => { 2 => 'Location' } },
+    Timestamp => {
+        Writable => 'integer',
+        Shift => 'Time',
+        Groups => { 2 => 'Time' },
+        ValueConv => 'ConvertUnixTime($val / 1000, 1, 3)',
+        ValueConvInv => 'int(GetUnixTime($val, 1) * 1000)',
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,undef,1)',
+    },
+);
+my %sEarthPose = (
+    STRUCT_NAME => 'EarthPose',
+    NAMESPACE => { EarthPose => 'http://ns.google.com/photos/dd/1.0/earthpose/' },
+    Latitude  => { Writable => 'real', Groups => { 2 => 'Location' }, %latConv },
+    Longitude => { Writable => 'real', Groups => { 2 => 'Location' }, %longConv },
+    Altitude  => {
+        Writable => 'real',
+        Groups => { 2 => 'Location' },
+        PrintConv => '"$val m"',
+        PrintConvInv => '$val=~s/\s*m$//;$val',
+    },
+    RotationX => { Writable => 'real', Groups => { 2 => 'Location' } },
+    RotationY => { Writable => 'real', Groups => { 2 => 'Location' } },
+    RotationZ => { Writable => 'real', Groups => { 2 => 'Location' } },
+    RotationW => { Writable => 'real', Groups => { 2 => 'Location' } },
+    Timestamp => {
+        Writable => 'integer',
+        Shift => 'Time',
+        Groups => { 2 => 'Time' },
+        ValueConv => 'ConvertUnixTime($val / 1000, 1, 3)',
+        ValueConvInv => 'int(GetUnixTime($val, 1) * 1000)',
+        PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val,undef,1)',
+    },
+);
+my %sVendorInfo = (
+    STRUCT_NAME => 'VendorInfo',
+    NAMESPACE   => { VendorInfo => 'http://ns.google.com/photos/dd/1.0/vendorinfo/' },
+    Model => { },
+    Manufacturer => { },
+    Notes => { },
+);
+my %sAppInfo = (
+    STRUCT_NAME => 'AppInfo',
+    NAMESPACE   => { AppInfo => 'http://ns.google.com/photos/dd/1.0/appinfo/' },
+    Application => { },
+    Version => { },
+    ItemURI => { },
+);
+
+# camera-raw defaults
+%Image::ExifTool::XMP::crd = (
+    %xmpTableDefaults,
+    INIT_TABLE => \&Init_crd,
+    GROUPS => { 1 => 'XMP-crd', 2 => 'Image' },
+    NAMESPACE   => 'crd',
+    AVOID => 1,
+    TABLE_DESC => 'Photoshop Camera Defaults namespace',
+    NOTES => 'Adobe Camera Raw Defaults tags.',
+    # (tags added dynamically when WRITE_PROC is called)
+);
+
+# XMP Dynamic Media namespace properties (xmpDM)
 %Image::ExifTool::XMP::xmpDM = (
     %xmpTableDefaults,
     GROUPS => { 1 => 'XMP-xmpDM', 2 => 'Image' },
     NAMESPACE => 'xmpDM',
-    NOTES => 'XMP Dynamic Media schema tags.',
+    NOTES => 'XMP Dynamic Media namespace tags.',
     absPeakAudioFilePath=> { },
     album               => { },
@@ -139,4 +218,5 @@
     director        => { },
     directorPhotography => { },
+    discNumber      => { }, #12
     duration        => { Struct => \%sTime },
     engineer        => { },
@@ -156,8 +236,10 @@
     logComment      => { },
     loop            => { Writable => 'boolean' },
+    lyrics          => { }, #12
     numberOfBeats   => { Writable => 'real' },
     markers         => { Struct => \%sMarker, List => 'Seq' },
     metadataModDate => { Groups => { 2 => 'Time' }, %dateTimeInfo },
     outCue          => { Struct => \%sTime },
+    partOfCompilation=>{ Writable => 'boolean' }, #12
     projectName     => { },
     projectRef => {
@@ -213,4 +295,6 @@
     speakerPlacement=> { },
     startTimecode   => { Struct => \%sTimecode },
+    startTimeSampleSize => { Writable => 'integer' }, #PH
+    startTimeScale  => { }, #PH (real?)
     stretchMode     => {
         PrintConv => {
@@ -270,5 +354,5 @@
         },
     },
-    videoCompressor     => { },
+    videoCompressor => { },
     videoFieldOrder => {
         PrintConv => {
@@ -278,7 +362,7 @@
         },
     },
-    videoFrameRate      => { },
-    videoFrameSize      => { Struct => \%sDimensions },
-    videoModDate        => { Groups => { 2 => 'Time' }, %dateTimeInfo },
+    videoFrameRate  => { Writable => 'real' },
+    videoFrameSize  => { Struct => \%sDimensions },
+    videoModDate    => { Groups => { 2 => 'Time' }, %dateTimeInfo },
     videoPixelAspectRatio => { Writable => 'rational' },
     videoPixelDepth => {
